include:
  - project: accessable-net/gitlab-ci-templates
    file: android.yml
  - project: accessable-net/gitlab-ci-templates
    file: scheduled_rebase.yml

default:
  image: circleci/android:api-30

before_script:
  # - export JAVA_TOOL_OPTIONS="-Dhttp.proxyHost=$( echo ${http_proxy##http://} | cut -d':' -f1 ) -Dhttp.proxyPort=$( echo ${http_proxy##http://} | cut -d':' -f2 ) -Dhttps.proxyHost=$( echo ${https_proxy##http://} | cut -d':' -f1 ) -Dhttps.proxyPort=$( echo ${https_proxy##http://} | cut -d':' -f2 ) -Dhttp.nonProxyHosts=\"$( echo $no_proxy | tr ',' '|' )\""
  - echo -e "y\ny\ny\ny\ny\ny\ny\ny\n" | sdkmanager --licenses #--proxy=http --proxy_host=$( echo ${https_proxy##http://} | cut -d':' -f1 ) --proxy_port=$( echo ${https_proxy##http://} | cut -d':' -f2 )
  - export GRADLE_USER_HOME=`pwd`/.gradle
  - sudo chmod +x ./gradlew
  - export VERSION_NAME=$(grep -E "versionName " buildSrc/src/main/kotlin/ProtonMail.kt | awk '{print $5}' | sed s/\"//g)
  - export VERSION_CODE=$(grep -E "versionCode " buildSrc/src/main/kotlin/ProtonMail.kt | awk '{print $5}' | sed s/\"//g)
  - echo "App version name ${VERSION_NAME}"
  - echo "App version name ${VERSION_CODE}"
cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .gradle
    - '**/build'
    - '**/**/build'
    - '**/**/**/build'

variables:
  UPSTREAM_BRANCH: release

stages:
  - manual-release
  - analyze
  - build
  - test
  - bot-i18n
  - bot-release

#####################


android-assemble-release:
  extends: .android-assemble-release
  variables:
    ANDROID_BUILD_FLAVOR: assemblePlaystoreReleasePlayStore


#####################


.build-debug-common:
  stage: build
  script:
    - ./gradlew assembleBetaDebug
    - ./gradlew assembleBetaDebugAndroidTest
  artifacts:
    expire_in: 1 week
    paths:
      - app/build/outputs/apk

build debug:
  extends: .build-debug-common
  except:
    - develop
    - release
    - prerelease
    - tags
    - schedules

build debug develop:
  extends: .build-debug-common
  only:
    - develop
    - schedules
  script:
    - ./gradlew clean
    - ./gradlew assembleBetaDebug
    - ./gradlew assembleBetaDebugAndroidTest

build debug uitests:
  extends: .build-debug-common
  only:
    - schedules

build debug release:
  extends: .build-debug-common
  only:
    - release
    - prerelease
    - tags

build prerelease:
  stage: build
  except:
    - schedules
  only:
    - prerelease
    - tags
  # tags:
  #   - android
  script:
    - ./gradlew clean
    - ./gradlew assemblePlaystoreReleasePlayStore
  artifacts:
    expire_in: 3 week
    paths:
      - app/build/outputs

build release:
  stage: build
  except:
    - schedules
  only:
    - releases
  script:
    - ./gradlew clean
    - ./gradlew assemblePlaystoreReleasePlayStore
  artifacts:
    expire_in: 4 week
    paths:
      - app/build/outputs


.unit-tests-common:
  stage: test
  script:
    - ./gradlew -Pci --console=plain allTest

